Structured Connection ID Carrying Metadata
Internet-Draft draft-shi-quic-structured-connection-id-03
Hang Shi
Huawei Technologies
China
shihang9@huawei.com
Mengyao Han
China Unicom
hanmy12@chinaunicom.cn
16 October 2024
Transport
QUIC
Internet-Draft
This document describes a mechanism to carry the metadata in the QUIC connection ID to communicate with the intermediary.
About This Document
The latest revision of this draft can be found at https://VMatrix1900.github.io/draft-quic-structured-connection-id/draft-shi-quic-structured-connection-id.html. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-shi-quic-structured-connection-id/.
Source for this draft and an issue tracker can be found at https://github.com/VMatrix1900/draft-quic-structured-connection-id.
Introduction
Nowadays, media applications are usually able to dynamically adjust the size and quality of the stream to adapt to fluctuating network conditions. However, for the high throughput and low latency media traffic, adaptation only by the endpoint is not good enough, especially when the network condition is challenging, such as the wireless networks discussed in [I-D.kaippallimalil-tsvwg-media-hdr-wireless]. To this end, it is desirable to have the intermediary performing optimization for the endpoint. For example, low-priority packets can be dropped to save the resource when the network is congested.
One example of such an intermediary is the relay in the Media over QUIC working group. To quote the charter from the MoQ working group. "Media over QUIC (moq) will develop a simple low-latency media delivery solution for ingest and distribution of media. This solution addresses use cases including live streaming, gaming, and media conferencing and will scale efficiently." "Even when media content is end-to-end encrypted, the relays can access metadata needed for caching (such as timestamp), making media forwarding decisions (such as drop or delay under congestion), and so on."
Due to the end-to-end encryption of the QUIC, the intermediary does not have the necessary metadata to perform optimization. A similar problem exists when the media is encrypted and transferred using SRTP [RFC3711]. To solve the problem, [I-D.ietf-avtext-framemarking] defines an extension of the RTP header containing the video frame information. This document defines an extension of the QUIC header, using the connection ID to carry the necessary metadata. To mitigate the linkability between the multiple connection IDs of the same connection and protect privacy, the metadata MAY be encrypted and only decrypted by an authenticated intermediary. Similar to [I-D.ietf-quic-load-balancers], a configuration agent is used to distribute the encryption parameters and the template of the metadata.
Terminology
This document uses terms in the [I-D.ietf-quic-load-balancers]:
- "client" and "server" refer to the QUIC endpoint.
- Intermediary refers to a network element that forwards QUIC packets and does not possess the QUIC connection keys. Such an intermediary can be QUIC proxy defined in the MASQUE working group, wireless node described in the [I-D.kwbdgrr-tsvwg-net-collab-rqmts], and relay defined in the Media over QUIC working group.
- CID: Connection ID in the QUIC header.
- Configuration agent: An entity that distributes the encryption parameter and the template of the metadata field.
All wire formats will be depicted using the notation defined in Section 1.3 of [RFC9000].
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Architecture
Levarage Metadata In QUIC CID to communicate with intermediary

                             + ----------------+
                             | Configuration   |
         +-------------------+ agent(Optional) +-----------------+
        /                    +------+----------+                  \
       /Config Parameters and template of the Metadata field in CID\
      /                             |                               \
     /          _______             |              _______           \
+---V----+     (       )     +------v-------+     (       )     +-----v----+
| Client +----( Network )----+ Intermediary +----( Network )----+  Server  |
+--------+     (_______)     +--------------+     (_______)     +----------+

Figure 1 shows the architecture of the optimization intermediary. The sender, which can be either the client or server based on the direction of communication, incorporates metadata into the connection ID field as outlined in the referenced section (See Section 4). This metadata allows the intermediary to execute optimizations tailored to the information provided. Given that various applications may require the disclosure of distinct metadata to the intermediary, a standardized template is adopted to specify the metadata's content and structure. There are two primary methods for obtaining this template:
1. For each category of application, a specific template is crafted and cataloged within a new IANA registry. This approach leverages the global accessibility of the template definition, eliminating the need for its distribution by the configuration agent. The responsibility for developing these templates falls to the respective working groups or documents, which is beyond the scope of this document.
2. The configuration agent, operating within its domain, defines and disseminates the template. This strategy ensures the template's relevance and effectiveness is confined to the domain under the agent's control, tailored according to the capabilities of the network devices present.
If the network between the intermediary and endpoints is not trusted, the metadata MUST be encrypted. In such scenarios, the encryption parameters must be exclusively shared with authenticated intermediaries, potentially via the configuration agent. A viable encryption strategy might involve adopting the algorithm proposed in [I-D.ietf-quic-load-balancers], ensuring the security of the metadata.
The metadata field can also be modified by the intermediary, enabling the intermediary to pass the signal such as throughput advice as defined by SCONE WG to the end host.
Structured Connection ID
Format of structured CID

Structured Connection ID {
  Config Parameters (8),
  Metadata (40...152),
}

The format of the structured connection ID is shown in Figure 2. The content and the format of the metadata field are defined by a template, carrying the information such as media characteristics in Section 3.1 of [I-D.ietf-avtext-framemarking] and metadata in [I-D.kwbdgrr-tsvwg-net-collab-rqmts]
Coexistence with QUIC Load Balancer
As both the Metadata and Server ID share the same field within the Connection ID (CID), it's crucial to devise mechanisms that prevent conflicts and ensure their seamless coexistence.
If an intermediary serves dual roles as both the load balancer and the optimization node, and if both entities are underpinned by a unified trust relationship, then it is feasible to consolidate the Metadata and the Server ID specified in [I-D.ietf-quic-load-balancers]. This consolidation allows for the utilization of a singular Config Parameter and a shared encryption/decryption methodology.
Conversely, if the load balancer and the optimization node are separated, the Server ID and the Metadata needs to be segregated too. One option is to split the CID into two segments: one for the Server ID and the other for the metadata. Each segment would be governed by its own set of Config Parameters and subjected to individual encryption protocols, ensuring the integrity and segregation of the transmitted information.
Security Considerations
TBD
References
Normative References
[RFC3711]

The Secure Real-time Transport Protocol (SRTP)
M. Baugher
D. McGrew
M. Naslund
E. Carrara
K. Norrman
March 2004
RFC 3711
DOI 10.17487/RFC3711
[RFC9000]

QUIC: A UDP-Based Multiplexed and Secure Transport
J. Iyengar, Ed.
M. Thomson, Ed.
May 2021
RFC 9000
DOI 10.17487/RFC9000
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[I-D.kaippallimalil-tsvwg-media-hdr-wireless]

Media Handling Considerations for Wireless Networks
John Kaippallimalil
Futurewei
Sri Gundavelli
Cisco
Spencer Dawkins
Tencent America LLC
10 August 2024
Internet-Draft draft-kaippallimalil-tsvwg-media-hdr-wireless-05
[I-D.ietf-avtext-framemarking]

Video Frame Marking RTP Header Extension
Mo Zanaty
Cisco Systems
Espen Berger
Cisco Systems
Suhas Nandakumar
Cisco Systems
4 March 2024
Internet-Draft draft-ietf-avtext-framemarking-16
[I-D.ietf-quic-load-balancers]

QUIC-LB: Generating Routable QUIC Connection IDs
Martin Duke
Google
Nick Banks
Microsoft
Christian Huitema
Private Octopus Inc.
5 February 2024
Internet-Draft draft-ietf-quic-load-balancers-19
[I-D.kwbdgrr-tsvwg-net-collab-rqmts]

Requirements for Host-to-Network Collaboration Signaling
John Kaippallimalil
Futurewei
Dan Wing
Cloud Software Group Holdings, Inc.
Sri Gundavelli
Cisco
Sridharan Rajagopalan
Cloud Software Group Holdings, Inc.
Spencer Dawkins
Tencent America LLC
Mohamed Boucadair
Orange
14 October 2024
Internet-Draft draft-kwbdgrr-tsvwg-net-collab-rqmts-04